/* jshint esnext: true */
var jQuery, document, window, location, swal;
(function ($) {
    "use strict";

    const dh = {
        dev: 'CrazyDH',
        flex_center: 'flex_center',
        popupVdo: $('.mfg-popup')
    };

    dh.subMenu = $('.sub-menu');
    if (dh.subMenu.length) {
        dh.subMenu.each(function () {
            $(this).closest('li').addClass('has-dropdown');
        });
    }

    // preloader
    dh.fnPreloader = () => {
        dh.preloader = $('.preloader');
        if (dh.preloader.length) {
            dh.preloader.fadeOut(1000);
        }
    };


    // height configuration

    dh.heightConfig = () => {
        dh.autoHeight = customClass => {
            let minHeight = -1;
            customClass.each(function () {
                if ($(this).height() > minHeight) {
                    minHeight = $(this).height();
                }
            });
            customClass.height(minHeight).addClass(dh.flex_center);
        };
        
        
        dh.unmute = $('.mute--unmute .fa');
        if(dh.unmute.length){
            dh.unmute.on('click', function() {
                $(this).addClass('hide');
                $(this).siblings().removeClass('hide');
            });
        }
    };

    // smoothScroll
    dh.smoothScroll = () => {
        $('a.smoothScroll').on('click', function () {
            if (location.pathname.replace(/^\//, '') == this.pathname.replace(/^\//, '') ||
                location.hostname == this.hostname) {
                var target = $(this.hash);
                target = target.length ? target : $('[name=' + this.hash.slice(1) + ']');
                if (target.length) {
                    $('html,body').animate({
                        scrollTop: target.offset().top
                    }, 1000);
                    return false;
                }
            }
        });
    };


    // plugins

    dh.plugins = () => {
        
        if($.fn.stellar){
            dh.window = $(window);
            dh.window.stellar();
        }
        
        dh.vdoPop = $('.vdo--popup');
        if($.fn.magnificPopup){
            dh.vdoPop.each(function() {
                $(this).magnificPopup({
                    disableOn: 0,
                    type: 'iframe',
                    mainClass: 'mfp-fade',
                    removalDelay: 160,
                    preloader: true,
                    fixedContentPos: false
                });
            });
        }

        dh.mcForm1 = $('.dh--mc--form1');
        if ($.fn.ajaxChimp) {
            if (dh.mcForm1.length) {
                let listURL = dh.mcForm1.attr('action');
                dh.submitSpinner = dh.mcForm1.find('button i');
                dh.mcSubmit1 = dh.mcForm1.find('[type=submit]');
                dh.mcInp1 = dh.mcForm1.find('input');
                dh.mcSubmit1.on('click', () => {
                    dh.submitSpinner.removeClass('hidden');
                });
                dh.mcForm1.ajaxChimp({
                    url: listURL,
                    callback: resp => {
                        if (resp.result === 'success') {
                            swal("Good job!", "Please check your email and verify!", "success");
                            dh.submitSpinner.addClass('hidden');
                            dh.mcInp1.val('');
                        } else {
                            dh.mcForm1.addClass('animated shake').delay(1000).queue(function(next){
                                $(this).removeClass("animated shake");
                                next();
                            });
                            dh.submitSpinner.addClass('hidden');
                        }
                    }
                });
            }
        }
        
        dh.mainMenu = $('.dh--navigation--menu > ul');
        if($.fn.slicknav && dh.mainMenu){
            dh.mainMenu.slicknav({
                appendTo: '.dh--btn--col'
            });
        }

    };
    
    
    dh.customCode = () => {
        dh.fileUpload = $('#upload-project');
        dh.fileUpload.change(function() {
          $(this).prev('label').clone();
          var file = $('#upload-project')[0].files[0].name;
          $(this).prev('label').text(file);
        });
        
        dh.sameHeight = $('.same--height');
        if(dh.sameHeight.length){
            dh.sameHeight.each(function() {
                $(this).height($(this).width());
            });
        }
        
        
        dh.prvCls = $('.site_wrap, .dh--preview--wrap');
        $('.prvActive').on('click', function() {
            dh.prvCls.addClass('preview--active');
        });
        $('.prvClose').on('click', function() {
            dh.prvCls.removeClass('preview--active');
        });

        if($(window).width() < 768){
            dh.fixHeight = $('.fixed--height');
            dh.fixHeight.height(dh.fixHeight.height() + 50);
        }

    };
    
    
    dh.vdoFunc = () => {
        
        dh.vdoBg1 = $("#dh--vdobg--1");
        dh.playPauseNo = $('.play--pause span.no');
        dh.playBtn = $('.play--pause span.play');
        dh.pauseBtn = $('.play--pause span.pause');

        if($.fn.YTPlayer && dh.vdoBg1.length){
            dh.vdoBg1.YTPlayer();
            
            dh.vdoContent = $('.dh--video--content');
            
            dh.vdoBg1.on('YTPReady', function() {
                dh.playPauseNo.remove();
            });
            dh.vdoBg1.on('YTPPlay', function() {
                dh.vdoContent.addClass('active');
                dh.playBtn.addClass('hide');
                dh.pauseBtn.removeClass('hide');
            });
            dh.vdoBg1.on('YTPPause', function() {
                dh.vdoContent.removeClass('active');
                dh.pauseBtn.addClass('hide');
                dh.playBtn.removeClass('hide');
            });
        }
        
        dh.portVdo1 = $('.dh--port--video--1');
        
        if($.fn.YTPlayer && dh.portVdo1.length){
            dh.portVdo1.each(function() {
                $(this).YTPlayer();
            });
        }
        
        dh.portVdo2 = $('.dh--port--video--2');
        
        if($.fn.YTPlayer && dh.portVdo2.length){
            dh.portVdo2.each(function() {
                $(this).YTPlayer();
            });
        }
        
        dh.homeVdo4 = $('.dh--home--vdo--4');
        
        if($.fn.YTPlayer && dh.homeVdo4.length){
            dh.homeVdo4.YTPlayer();
        }
        
        if (dh.popupVdo.length && $.fn.magnificPopup) {
            dh.popupVdo.magnificPopup({
                disableOn: 0,
                type: 'iframe',
                mainClass: 'mfp-fade',
                removalDelay: 160,
                preloader: true,
                fixedContentPos: false
            });
        }
        
        $('.dh--gallery--wrap').magnificPopup({
            delegate: 'a',
            type: 'image',
            tLoading: 'Loading image #%curr%...',
            mainClass: 'mfp-with-zoom',
            gallery: {
                enabled: true,
                navigateByImgClick: true,
                preload: [0,1] // Will preload 0 - before current, and 1 after the current image
            },
            image: {
                tError: '<a href="%url%">The image #%curr%</a> could not be loaded.',
                titleSrc: function(item) {
                    return item.el.attr('title');
                }
            },
            zoom: {
                enabled: true,
                duration: 300,
                easing: 'ease-in-out', 
                opener: function(openerElement) {
                  return openerElement.is('a') ? openerElement : openerElement.find('a');
                }
            }
        });
        
    };
    
    
    dh.sliders = () => {
        if($.fn.slick){
            dh.portSlider1 = $('.dh--port--image--1');
            dh.portSlider1.each( function () {
                $(this).slick({
                    autoplay: true,
                    prevArrow: false,
                    nextArrow: false,
                    dots: true
                });
            });

            dh.portSlider2 = $('.dh--port--image--2');
            dh.portSlider2.each( function () {
                $(this).slick({
                    autoplay: true,
                    prevArrow: false,
                    nextArrow: false,
                    dots: false,
                    fade: true
                });
            });
        }
        
        
        if($.fn.owlCarousel){
            dh.teamCarousel = $('.dh--team--carousel');
            if(dh.teamCarousel.length){
                dh.teamCarousel.owlCarousel({
                    items: 4,
                    loop: true,
                    margin: 30,
                    autoplay: true,
                    smartSpeed: 700,
                    dots: false,
                    nav: true,
                    responsive: {
                        0: {
                            items: 1
                        },
                        480: {
                            items: 2
                        },
                        768: {
                            items: 3
                        },
                        992: {
                            items: 4
                        }
                    }
                });
            }
            dh.testimonialCarousel = $('.dh--testimonial--slider');
            if(dh.testimonialCarousel.length){
                dh.testimonialCarousel.owlCarousel({
                    items: 1,
                    loop: true,
                    autoplay: true
                });
            }
            dh.homeSlider = $('.dh--home--slider');
            if(dh.homeSlider.length){
                dh.homeSlider.owlCarousel({
                    items: 1,
                    loop: true,
                    autoplay: true,
                    dotsData: true,
                    animateOut: 'fadeOut',
                    animateIn: 'fadeInLeft'
                });
            }
        }
    };


    // console notice
    dh.consoleTxt = () => {
        dh.consoleStyle = [
            'font-size: 10px',
            'color: #ffffff',
            'background-color: #2e7d32',
            'display: block',
            'text-align: left',
            'font-weight: bold',
            'display: inline-block'
        ].join(';');
        console.log('%c SITE LOADED 100%, - Created by ' + dh.dev, dh.consoleStyle);
    };

    
    
    
    dh.isoSetup = (mainClass, menuClass, singleClass, mode) => {
        
        if(mode === undefined){
            mode = 'masonry';
        }
        
        if(singleClass === undefined){
            singleClass = '.isotope-item';
        }
        
        if(menuClass === undefined){
            menuClass = '.dh--isotepe--menu';
        }
        
        let isotopeMenu1 = $(menuClass);
        let isotope1 = $(mainClass);
        
        isotopeMenu1.on('click', function() {
            isotopeMenu1.removeClass('active');
            $(this).addClass('active');
            let selector = $(this).attr('data-filter'); 
            isotope1.isotope({ 
                filter: selector,
                itemSelector: singleClass,
                layoutMode: mode,
                animationOptions: { 
                    duration: 750, 
                    easing: 'linear', 
                    queue: false, 
                } 
            });
            return false;
        });

        $(window).on('load', function() {
            isotope1.isotope({
                itemSelector: singleClass,
                layoutMode: mode,
            });  
        });
    };
    
    dh.isoSetup('.dh--isotope--1', '.dh--isotope--menu--1 li');
    dh.isoSetup('.dh--isotope--2', '.dh--isotope--menu--2 li', '.isotope-item', 'fitRows');
    dh.isoSetup('.dh--isotope--3', '.dh--isotope--menu--3 li');
    dh.isoSetup('.dh--isotope--4', '.dh--isotope--menu--4 li');
    
    dh.masonrySet = (mainClass, singleClass) => {
        mainClass = $(mainClass);
        mainClass.masonry({
            itemSelector: singleClass
        });
        
        $(window).on('load', function() {
            mainClass.masonry({
                itemSelector: singleClass
            });
        });
    };
    
    dh.masonrySet('.default--masonry', '.default--masonry > div');
    dh.masonrySet('.dh--gallery--wrap', '.dh--gallery--wrap > div');

    // all functions of document ready
    dh.docReady = () => {
        dh.fnPreloader();
        dh.heightConfig();
        dh.smoothScroll();
        dh.plugins();
        dh.sliders();
        dh.vdoFunc();
        dh.customCode();
    };

    // all functions of window load
    dh.winLoad = () => {
        dh.consoleTxt();
        dh.heightConfig();
    };


    $(document).ready(dh.docReady);
    $(window).on('load', dh.winLoad);



})(jQuery);
